import greenfoot.*;

/**
 * Write a description of class Gamers here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Gamers extends Actor
{
    private static final double WALKING_SPEED = 5.0;
    
    public Gamers()
    {
    }

    /**
     * Do whatever the wombat likes to to just now.
     */
    public void act()
    {
    }
    
    
    /**
     * Turn 'angle' degrees towards the right (clockwise).
     */
    public void turn(int angle)
    {
        setRotation(getRotation() + angle);
    }
    

    /**
     * Move forward in the current direction.
     */
    public void move()
    {
        double angle = Math.toRadians(getRotation());
        int x = (int) Math.round(getX() + Math.cos(angle) * WALKING_SPEED);
        int y = (int) Math.round(getY() + Math.sin(angle) * WALKING_SPEED);
     
        
        // now make sure that we are not stepping out of the world
        if(x >= getWorld().getWidth()) {
            x = getWorld().getWidth() - 1;
        }
        if(x < 0) {
            x = 0;
        }
        if(y >= getWorld().getHeight()) {
            y = getWorld().getHeight() - 1;
        }
        if(y < 0) {
            y = 0;
        }
        if(getGameField().checkStep(x,y)){
        setLocation(x, y);
        }
        
    }

    
    /**
     * Test if we are close to one of the edges of the world. Return true is we are.
     */
    public boolean atWorldEdge()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
    }
    

    
    /**
     * Return the world object.
     */
    public GameField getGameField()
    {
        return (GameField) getWorld();
    }
}
